import { useState, useEffect } from 'react';
import Students from './components/Students';
import Header from './components/Header'
import AddStudent from './components/AddStudent';
import 'bootstrap/dist/css/bootstrap.min.css';

function App() {

  const [studentsData, setStudentsData] = useState([]);

  const fetchStudents = async () => {
    const response = await fetch('http://localhost:5000/students');
    const data = await response.json();
    return data;
  }

  useEffect(() => {
    const setStudents = async () => {
      const data = await fetchStudents()
      setStudentsData(data);
    }
    setStudents();
  })

  const addStudent = async (data) => {
    if (!data.text) {
      alert('Please Enter Student Name');
      return;
    } else if (!data.mark) {
      alert('Please Enter Mark')
      return;
    }
    const response = await fetch('http://localhost:5000/students', { method: 'POST', headers: { 'content-type': 'application/json' }, body: JSON.stringify(data) });
    const datas = await response.json();
    setStudentsData([...studentsData, datas]);

  };

  const deleteStudent = async (id) => {
    await fetch(`http://localhost:5000/students/${id}`, { method: 'DELETE' })
    setStudentsData(studentsData.filter((data) => data.id !== id))
  }

  return (
    <div className="c-container">
      <Header />
      <AddStudent addStudent={addStudent} />
      {studentsData.map((data, index) => (
        <Students key={data.id} index={index} id={data.id} mark={data.mark} grade={data.grade} onAddStudent={addStudent} onDeleteStudent={deleteStudent}>{data.text}</Students>
      ))}
    </div>

  );
}

export default App;
